live-build/helpers/lh_source_usb-hdd

114 lines
2.5 KiB
Plaintext
Raw Normal View History

2007-09-23 08:04:46 +00:00
#!/bin/sh
2007-09-23 08:05:11 +00:00
# lh_source_usb-hdd(1) - build source usb-hdd image
2007-09-23 08:04:48 +00:00
# Copyright (C) 2006-2007 Daniel Baumann <daniel@debian.org>
#
# live-helper comes with ABSOLUTELY NO WARRANTY; for details see COPYING.
# This is free software, and you are welcome to redistribute it
# under certain conditions; see COPYING for details.
2007-09-23 08:04:46 +00:00
set -e
2007-09-23 08:05:11 +00:00
# Including common functions
LH_BASE="${LH_BASE:-/usr/share/live-helper}"
for FUNCTION in "${LH_BASE}"/functions/*.sh
2007-09-23 08:04:46 +00:00
do
2007-09-23 08:05:11 +00:00
. "${FUNCTION}"
2007-09-23 08:04:46 +00:00
done
2007-09-23 08:05:11 +00:00
# Setting static variables
2007-09-23 08:04:48 +00:00
DESCRIPTION="build source image"
HELP=""
USAGE="${PROGRAM} [--force]"
Arguments "${@}"
2007-09-23 08:04:46 +00:00
# Reading configuration files
2007-09-23 08:04:52 +00:00
Read_conffile config/common
2007-09-23 08:04:46 +00:00
Read_conffile config/bootstrap
2007-09-23 08:04:49 +00:00
Read_conffile config/chroot
2007-09-23 08:04:52 +00:00
Read_conffile config/binary
Read_conffile config/source
2007-09-23 08:05:18 +00:00
Read_conffile "${LH_CONFIG}"
2007-09-23 08:04:46 +00:00
Set_defaults
2007-09-23 08:05:17 +00:00
if [ "${LH_SOURCE}" != "enabled" ]
2007-09-23 08:04:46 +00:00
then
exit 0
fi
2007-09-23 08:05:17 +00:00
if ! echo "${LH_SOURCE_IMAGES}" | grep -qs usb-hdd
2007-09-23 08:05:11 +00:00
then
exit 0
fi
Echo_message "Begin building source usb-hdd image..."
# Requiring stage file
Require_stagefile .stage/source_debian
# Checking stage file
Check_stagefile .stage/source_usb-hdd
# Checking lock file
Check_lockfile .lock
# Creating lock file
Create_lockfile .lock
# Checking depends
Check_package chroot/sbin/mkdosfs dosfstools
Check_package chroot/sbin/parted parted
# Installing depends
Install_package
# Remove old source
if [ -f source.img ]
then
rm -f source.img
fi
# Everything which comes here needs to be cleaned up,
DU_DIM="$(du -ms source | cut -f1)"
REAL_DIM="$(expr ${DU_DIM} + ${DU_DIM} / 50)" # Just 2% more to be sure, need something more sophistcated here...
2007-09-23 08:05:11 +00:00
dd if=/dev/zero of=source.img bs=1024k count=${REAL_DIM}
FREELO="$(${LH_LOSETUP} -f)"
2007-09-23 08:05:11 +00:00
if [ ! -b chroot/${FREELO} ]
then
MAKEDEV="true"
mv chroot/dev chroot/dev.tmp
find /dev | cpio -dmpu chroot
fi
echo "!!! The following error/warning messages can be ignored !!!"
lh_losetup $FREELO source.img 0
Chroot "parted -s ${FREELO} mklabel msdos" || true
Chroot "parted -s ${FREELO} mkpartfs primary fat16 0.0 100%" || true
Chroot "parted -s ${FREELO} set 1 lba off" || true
${LH_LOSETUP} -d ${FREELO}
lh_losetup $FREELO source.img 1
Chroot " mkfs.vfat -F 16 -n DEBIAN_LIVE ${FREELO}"
mkdir -p source.tmp
${LH_ROOT_COMMAND} mount ${FREELO} source.tmp
cp -r source/* source.tmp
${LH_ROOT_COMMAND} umount source.tmp
rmdir source.tmp
${LH_LOSETUP} -d ${FREELO}
echo "!!! The above error/warning messages can be ignored !!!"
if [ -n "${MAKEDEV}" ]
then
2007-09-23 08:05:13 +00:00
rm -rf chroot/dev
2007-09-23 08:05:11 +00:00
mv chroot/dev.tmp chroot/dev
fi
# Removing depends
Remove_package
# Creating stage file
Create_stagefile .stage/source_usb-hdd